package net.locusworks.lsproject.driver;
import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintStream;

import net.locusworks.lsproject.gui.DebugConsole;
import net.locusworks.lsproject.gui.StartupWindow;

/**
 * Contains the main (start-up) function.
 */
public class Program {
	private static DebugConsole console;
	
	/**
	 * Entry point of the program.
	 */
	public static void main(String[] args) {
		console = new DebugConsole();
		
		setupStreams();
		
		new StartupWindow();
	}
	
	/**
	 * Set the typical output streams to a window. This means that output sent through System.out
	 * and System.err are sent instead to a designated console window.
	 */
	public static void setupStreams() {
		PrintStream errorStream = new PrintStream(new OutputStream() {
			@Override
			public void write(int c) throws IOException {
				write(new byte[] { Byte.parseByte(Integer.toString(c)) });
			}
			
			public void write(byte[] b) {
				console.writeError(new String(b));
			}
		});
		
		PrintStream outputStream = new PrintStream(new OutputStream() {
			@Override
			public void write(int c) throws IOException {
				write(new byte[] { Byte.parseByte(Integer.toString(c)) });
			}
			
			public void write(byte[] b) {
				console.writeString(new String(b));;
			}
		});
		
		//System.setErr(errorStream);
		System.setOut(outputStream);
	}
}
