package net.locusworks.lsproject.gui.helper;

import java.awt.Image;
import java.awt.Toolkit;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;

import javax.swing.JOptionPane;


public class ImageHelper {
  
  public static Image getImageFromResource(String imageName) {
    try(ByteArrayOutputStream baos = new ByteArrayOutputStream(); InputStream is = ImageHelper.class.getClassLoader().getResourceAsStream(imageName)) {
      byte[] buff = new byte[1024];
      int read = 0;
      while((read = is.read(buff)) > -1) {
        baos.write(buff, 0, read);
      }
    // Load window icon.
      return Toolkit.getDefaultToolkit().createImage(baos.toByteArray());
    } catch (IOException ex) {
      JOptionPane.showMessageDialog(null, 
          "An error occured while trying to load the assets file:\n" + ex.getMessage(), 
          "Error loading file!", 
          JOptionPane.ERROR_MESSAGE);
    }
    return null;
  }

}
