package net.locusworks.lsproject.object;

import java.io.Serializable;

/**
 * 
 */
public class RoutingTable extends DijkstraEngine implements Serializable {
	private static final long serialVersionUID = 848488383828283L;
	private Router parentRouter;
	
	/**
	 * 
	 * @param _parentRouter
	 */
	public RoutingTable(Router _parentRouter){
		parentRouter = _parentRouter;
	}
	
	/**
	 * Provide access to this table's parent router.
	 * @return Parent router which this routing table is for.
	 */
	public Router getRouter() {
		return parentRouter;
	}
	
	/**
	 * Perform Dijkstra's algorithm. Should be called every time the router is changed.
	 */
	public void recalculate() {
		execute(parentRouter, null);
	}
}