package object;

import static org.junit.Assert.*;
import org.junit.Before;
import java.awt.Point;

import org.junit.Test;

import net.locusworks.lsproject.object.Connection;
import net.locusworks.lsproject.object.Path;
import net.locusworks.lsproject.object.Router;

public class PathTest {
	private Path path;
	private Path path2;
	private final int expectedTotalCost = 9;
	
	@Before
	public void setUpBeforeClass(){
		Router[] routers = new Router[10];
		
		for(int i = 0; i < 10; i++){
			Router router = new Router("192.168.1."+ i, new Point(0, 0));	
			routers[i] = router;
		}
		
		for(int i = 0; i < 9; i++){
			Connection connection = new Connection("192.168.1."+i, "192.168.1."+(i+1),
					1);
			routers[i].addConnection(connection);
			routers[i+1].addConnection(connection);
		}
		
		path = new Path(routers, expectedTotalCost);
		path2 = new Path(routers, expectedTotalCost);
		
	}
	@Test
	public void testPath() {
		
		for(int i = 0; i < 8; i++){
			if(path.hasNext() == false|| path2.hasNext() == false){
				fail("Has Next failed at " + i + ". Should Never be False but was False");
			}
			assertEquals(path.getNext(), path2.getNext());
		}
	}


	@Test
	public void testGetTotalCost() {
		assertEquals(expectedTotalCost, path.getTotalCost());
	}
	
	@Test
	public void testGetNext(){
		for(int i = 0; i < 9; i++){
			if(path.getNext() == null){
				fail("getNext reached null. Should never reach it");
			}
		}
	}
	
	@Test
	public void testHasNext(){
		for (int i = 0; i < 9; i++){
			path.getNext();
			if(path.hasNext() == false){
				fail("hasNext reached the end of the elements");
			}
		}
	}
}
